#include "bits/stdc++.h"

using namespace std;

int main() {
  // Wczytujemy opis.
  string opis;
  cin >> opis;

  // Początkowe współrzedne ustalamy na (0,0).
  int x = 0, y = 0;

  // I trzymamy mapę odcinków pionowych, gdzie kluczem jest współrzędna y,
  // a wartościami współrzędne x (konkretniej oznacza ona odcinek od (x,y) do
  // (x,y+1)).
  map<int, vector<int>> odcinki_pionowe;
  for (char litera : opis) {
    if (litera == 'G') {
      // Dla ruchu w górę, dodajemy odcinek (x,y) do (x,y+1).
      odcinki_pionowe[y].push_back(x);
      // Po czym przesuwamy współrzędną y o 1 w górę.
      y++;
    } else if (litera == 'D') {
      // Dla ruchu w górę, dodajemy odcinek (x,y-1) do (x,y).
      odcinki_pionowe[y - 1].push_back(x);
      // Po czym przesywamy współrzędną y o 1 w dół.
      y--;
    } else if (litera == 'P') {
      // Dla odcinków poziomych nie zapisujemy ich, tylko
      // odpowiednio modyfikujemy współrzędną x.
      x++;
    } else if (litera == 'L') {
      x--;
    }
  }

  // Finalnie liczymy pole figury.
  // Zwróć uwagę, że pole może być większe niż zakres typu int,
  // zatem używamy zmiennej typu long long.
  long long pole = 0;
  // Iterujemy się po wszystkich współrzędnych y, które zapisaliśmy.
  for (auto &[y, odcinki] : odcinki_pionowe) {
    // Sortujemy listę odcinków.
    sort(odcinki.begin(), odcinki.end());
    // Dodajemy odległość pomiędzy odcinkiem otwierającym (odcinki[i])
    // i zamykającym figurę (odcinki[i+1]).
    for (int i = 0; i < odcinki.size(); i += 2) {
      pole += odcinki[i + 1] - odcinki[i];
    }
  }

  // Finalnie wypisujemy wynik.
  cout << pole << "\n";
}